Attribute VB_Name = "CS_Cswin"
'Cs_Cswin V1.01 July 26, 2008.

Option Explicit
Option Private Module
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private allowdims, requiredims As String
Private allowtotal, manualweight As String
Private doclbl As Integer
Private dispman As Boolean
Private dispord As Boolean

Public Sub CS_ax310()

    Dim rtnstr As String
    rtnstr = SendNet("FIRSTLOGIN" & msgdel)
    DbfIndex CS32.ShipDir + "cs_acct.fil", "RecNo()"
    
End Sub

Public Sub CS_ax320()

    Dim cswinvars, rtnstr As String
    
    ReadSettings
    doclbl = 0
    xtracsfields = "FROM1" & msgdel & "FROM2" & msgdel & "FROM3" & msgdel
    xtracsfields = xtracsfields & "FROM4" & msgdel & "CONSEMAIL" & msgdel
    CS32.XVars.Retrieve
    
    cswinvars = "LOGIN" & msgdel & CS32.GetVar("XUSERNAME") & msgdel
    For XN1 = 0 To CS32.XVars.Fields.Count - 1
        cswinvars = cswinvars & CS32.XVars.Fields(XN1).Name & msgdel
    Next XN1
    cswinvars = cswinvars & xtracsfields
    rtnstr = SendNet(cswinvars)

    SendLogos
    
End Sub

Public Sub CS_ax410()
    
    Dim msg, rtnstr As String
    Dim myvars As KiDataView
    
    errflag = "MAN"
    Set myvars = CS32.XXVars
    myvars.Retrieve
    msg = "FIELD1" & msgdel & myvars.Fields.Item("ord_cnt").Value & msgdel
    msg = msg & myvars.Fields.Item("carrier").Value & msgdel
    rtnstr = SendNet(msg)
    If rtnstr = "NOTHING" Or rtnstr = "" Then
        'Done shipment
    Else
        CS32.RepeatTrans
        Set myvars = CS32.XVars
        myvars.Retrieve
        RetrvVars rtnstr, myvars
        CS32.SetAutoRecord
        CS32.GotoRecord
        CS32.SetVar "xpkgid", myvars.Fields.Item("pkgid").Value
        SwitchTo CS32
    End If
    
End Sub

Public Sub CS_AfterCust()

    'Called after cust field in Clippership. Looks up cust in customer file.
    Dim rtnstr As String
    Dim myvars As KiDataView
    
    If Val(CS32.GetVar("xord_cnt")) = 0 Then
        Set myvars = CS32.XVars
        myvars.Retrieve
        If Len(Trim(myvars.Fields.Item("CUST").Value)) > 0 Then
            rtnstr = SendNet("CUSTLOOKUP" & msgdel & PopVars(myvars))
            If Len(Trim(rtnstr)) > 0 Then
                RetrvVars rtnstr, myvars
            End If
        Else
            rtnstr = SendNet("CHEKCUST" & msgdel)
        End If
    End If

End Sub

Public Sub CS_BeforeLastField()

    'Called before weight field, to run the .net weight loop.
    If NetCarrierCheck("X") Then
        Dim msg As String, rtnstr, xwgt As String
        Dim myvars As KiDataView
    
        Set myvars = CS32.XVars
        myvars.Retrieve
        If Val(myvars.Fields.Item("ord_cnt").Value) = 0 Then
            CS32.ReadScale
            xwgt = CS32.GetVar("xact_wgt")
            msg = "WGT" & msgdel & "FIRST" & msgdel
            msg = msg & Trim(xwgt) & msgdel & allowdims & msgdel & requiredims & msgdel
            msg = msg & allowtotal & msgdel & manualweight & msgdel
            msg = msg & PopVars(myvars)
            rtnstr = SendNet(msg)
            Do While rtnstr = "GETNEXT"
                CS32.SetVar "xact_wgt", "0"
                CS32.ReadScale
                xwgt = CS32.GetVar("xact_wgt")
                msg = "WGT" & msgdel & msgdel
                msg = msg & Trim(xwgt) & msgdel & allowdims & msgdel & requiredims & msgdel
                msg = msg & allowtotal & msgdel & manualweight & msgdel
                rtnstr = SendNet(msg)
            Loop
            If rtnstr = "ERROR" Then
                CS32.GotoField 1
            Else
                CS32.SetVar "xact_wgt", rtnstr
                CS32.GotoRecord
            End If
        End If
    End If
   
End Sub


Public Sub CS_ax550()

    If NetCarrierCheck("X") Then
        Dim rtnstr As String
        Dim myvars As KiDataView
    
        errflag = "CSWIN"
        If Val(CS32.GetVar("xord_cnt")) = 0 Then
            Set myvars = CS32.XVars
            myvars.Retrieve
        
            rtnstr = SendNet("CHEKADDR" & msgdel & PopVars(myvars))
            If Len(Trim(rtnstr)) > 0 Then
                RetrvVars rtnstr, myvars
            End If
        
            rtnstr = SendNet("CHEKWGT" & msgdel)
            If Len(Trim(rtnstr)) > 0 Then
                RetrvVars rtnstr, myvars
            End If
    
            rtnstr = SendNet("AFTERLASTFIELD" & msgdel)
            If Len(Trim(rtnstr)) > 0 Then
                RetrvVars rtnstr, myvars
            End If
        End If
    End If
    
End Sub

Public Sub CS_ax610()

    If NetCarrierCheck("X") Then
        Dim msg As String, rtnstr As String
        Dim myvars As KiDataView
        Dim n As Long
    
        Set myvars = CS32.XVars
        myvars.Retrieve
        msg = "BEFORERATE" & msgdel & PopVars(myvars)
        rtnstr = SendNet(msg)
        If Len(Trim(rtnstr)) > 0 Then
            RetrvVars rtnstr, myvars
        End If
    End If

End Sub

Public Sub CS_ax620()
        
    If NetCarrierCheck("X") Then
        Dim msg As String, rtnstr As String
        Dim myvars As KiDataView
        Dim n As Long
    
        Set myvars = CS32.XVars
        'XN3 = GetTickCount
        'AsciiFile.AppendLineTo "perf.log", "Before Retrieve: " & CStr(GetTickCount() - XN3)
        myvars.Retrieve
        msg = "RATE" & msgdel & PopVars(myvars)
        rtnstr = SendNet(msg)
        If Len(Trim(rtnstr)) > 0 Then
            RetrvVars rtnstr, myvars
        End If
    End If
    
End Sub

Public Sub CS_ax630()

    If NetCarrierCheck("X") Then
        Dim rtnstr As String
        Dim myvars As KiDataView

        Set myvars = CS32.XVars
        myvars.Retrieve
        rtnstr = SendNet("AFTERRATE" & msgdel & PopVars(myvars))
        If Len(Trim(rtnstr)) > 0 Then
            RetrvVars rtnstr, myvars
        End If
    Else
        SendTo CS32, "ENABLERECORD"
    End If
    
End Sub

Public Sub CS_ax710()

    If NetCarrierCheck("X") Then
        Dim msg As String, rtnstr As String
        Dim myvars As KiDataView
    
        Set myvars = CS32.XVars
        myvars.Retrieve
        msg = "RECORD" & msgdel & PopVars(myvars)
        rtnstr = SendNet(msg)
        If Len(Trim(rtnstr)) > 0 Then
            RetrvVars rtnstr, myvars
        End If
    
        If errset = 0 Then
            lblprinter.Prntlbl
        End If
        errflag = "MAN"
    End If
    
End Sub

Public Sub CS_ax810()

    If NetCarrierCheck("XX") Then
        Dim rtnstr As String
    
        If doclbl = 1 Then
            lblprinter.doclbl
        End If
        If dispord Then
            rtnstr = SendNet("ENDORD" & msgdel & "D" & msgdel)
        Else
            rtnstr = SendNet("ENDORD" & msgdel & " " & msgdel)
        End If
    End If
    
End Sub

Public Sub CS_axvoid()

    If NetCarrierCheck("XX") Then
        Dim rtnstr As String
        Dim myvars As KiDataView
        
        Set myvars = CS32.XXVars
        myvars.Retrieve
        rtnstr = SendNet("VOID" & msgdel & PopVars(myvars))
    End If
    
End Sub

Public Sub SpecServ()

    If NetCarrierCheck("X") Then
        Dim rtnstr As String
        Dim myvars As KiDataView
    
        errflag = "MAN"
        Set myvars = CS32.XVars
        myvars.Retrieve
        rtnstr = SendNet("SPECSERV" & msgdel & PopVars(myvars))
        If Len(Trim(rtnstr)) > 0 Then
            RetrvVars rtnstr, myvars
            rtnstr = "Charges: $ " & Trim(CS32.GetVar("xtot_chg"))
            'Make sure have only 2 decimal places
            If InStr(1, rtnstr, ".") < (Len(Trim(rtnstr)) - 2) Then
                rtnstr = SubStr(rtnstr, 1, InStr(1, rtnstr, ".") + 2)
            End If
        
            CS32.SetVar "RIGHTBOTTOM", rtnstr
        End If
        errflag = "CSWIN"
        CS32.SetVar "XQUIT", "YES"
    End If
    
End Sub

Public Sub EditCustS()

    Dim rtnstr As String
    Dim myvars As KiDataView
        
    Set myvars = CS32.XVars
    myvars.Retrieve
    rtnstr = SendNet("EDITCUSTS" & msgdel & PopVars(myvars))
    If Len(Trim(rtnstr)) > 0 Then
        RetrvVars rtnstr, myvars
    End If
    
End Sub

Public Sub EditCustD()

    Dim rtnstr As String
    Dim myvars As KiDataView
        
    Set myvars = CS32.XVars
    myvars.Retrieve
    rtnstr = SendNet("EDITCUSTD" & msgdel & PopVars(myvars))
    If Len(Trim(rtnstr)) > 0 Then
        RetrvVars rtnstr, myvars
    End If
    
End Sub

Public Sub ChekCust()

    Dim msg As String, rtnstr As String
    Dim myvars As KiDataView
    Dim n As Long
    
    Set myvars = CS32.XVars
    myvars.Retrieve
    msg = "CHEKCUST" & msgdel & PopVars(myvars)
    rtnstr = SendNet(msg)
    If Len(Trim(rtnstr)) > 0 Then
        RetrvVars rtnstr, myvars
    End If

End Sub

Public Sub ChekOrd()

    Dim msg As String, rtnstr As String
    Dim myvars As KiDataView
    Dim n As Long
    
    Set myvars = CS32.XVars
    myvars.Retrieve
    msg = "CHEKORD" & msgdel & PopVars(myvars)
    rtnstr = SendNet(msg)
    If Len(Trim(rtnstr)) > 0 Then
        RetrvVars rtnstr, myvars
    End If

End Sub

Public Sub CswinClose(carrier As String, account As Integer)

    Dim rtnstr As String
    Dim xreport As String
    
    xreport = CS32.dailyFile
    rtnstr = SendNet("AFTCLOSE" & msgdel & Trim(carrier) & msgdel & Trim(Str(account)) & msgdel & xreport & msgdel)
    
End Sub

Public Sub MaintainU()

    Dim rtnstr As String
    rtnstr = SendNet("MAINTAINU" & msgdel)
    
End Sub

Public Sub ReportEdi()

    Dim rtnstr As String
    Dim xreport As String
    
    xreport = CS32.GetVar("xreport")
    ' Note - last argument is display flag for Report Writer:D- display on screen, empty- send to printer
    If dispman Then
        rtnstr = SendNet("EDI" & msgdel & Trim(xreport) & msgdel & "D" & msgdel)
    Else
        rtnstr = SendNet("EDI" & msgdel & Trim(xreport) & msgdel & " " & msgdel)
    End If
    
    If Left(rtnstr, 5) = "LABEL" Then
        Dim label As String
        label = SubToken(rtnstr, 2, msgdel)
        If PrintLabels Then
            lblprinter.Start
            lblprinter.OutputText label
            lblprinter.Despatch
            lblprinter.Terminate
        End If
        If lbldisp Then
            MsgBox label, , "ReportEdi.label"
        End If
    End If
    
End Sub

Public Sub ReprintLbl()

    ' Note that this function requires that we be able to receive onvsbF* events from Clippership,
    ' which apparently requires KI 2.0 or later and CS 11.0 or later. (I think - the help file
    ' for 11 mentions onvsbF*, while that for 10 does not. I know that these events do not work
    ' in 9.0.06.)
    If NetCarrierCheck("XX") Then
        ' Read in the correct return address, from the account file.
        Dim AcctFile As KiDataView
        Set AcctFile = DbfLookup(CS32.ShipDir + "cs_acct.fil", Val(CS32.GetVar("xxaccount")), True)
        SendTo CS32, "XFROM1", AcctFile.Fields.Item("FROM1")
        SendTo CS32, "XFROM2", AcctFile.Fields.Item("FROM2")
        SendTo CS32, "XFROM3", AcctFile.Fields.Item("FROM3")
        SendTo CS32, "XFROM4", AcctFile.Fields.Item("FROM4")
        
        'Call routine to print the label.
        lblprinter.RePrntlbl
    End If
    
End Sub

Public Sub ClearTransBtn()

    Dim rtnstr As String
    rtnstr = SendNet("CLEARTRANS" & msgdel)
    
End Sub

Public Function NetCarrierCheck(xstring As String) As Boolean

    Dim mycar As String

    mycar = Trim(CS32.GetVar(xstring & "CARRIER"))
    If Len(mycar) = 0 Then
        ' Make sure that carrier isn't empty
        NetCarrierCheck = False
    Else
        mycar = PadR(mycar, 6) + msgdel
        If At(mycar, netcarlist) = 0 Then
            'Carrier wasn't found. Therefore isn't .net, and so don't call .net.
            NetCarrierCheck = False
        Else
            'Carrier was found. Call .net code.
            NetCarrierCheck = True
        End If
    End If

End Function

Private Sub ReadSettings()

    'Read in system settings from ini file

    Dim fname As String
    Dim inivalue As String
    fname = IniRead(CS32.ShipDir + "evcpath.ini", "Paths", "appdir") + "Canlogix.ini"
    If fExist(fname) Then
        inivalue = IniRead(fname, "Label", "Display", "N")
        If inivalue = "Y" Then
            lbldisp = True
        Else
            lbldisp = False
        End If
        lblHeat = IniRead(fname, "Label", "Heat", "D13")
        lblSpeed = IniRead(fname, "Label", "Speed", "S2")
        lblOrigin = IniRead(fname, "Label", "Origin", "R15,0")
        inivalue = IniRead(fname, "Reports", "DisplayMan", "N")
        If inivalue = "Y" Then
            dispman = True
        Else
            dispman = False
        End If
        inivalue = IniRead(fname, "Reports", "DisplayOrd", "N")
        If inivalue = "Y" Then
            dispord = True
        Else
            dispord = False
        End If
        allowdims = IniRead(fname, "Weight", "allowdims", "Y")         ' Flag for whether to display dims on weight dialog
        requiredims = IniRead(fname, "Weight", "requiredims", "N")     ' Flag for whether to allow empty dims
        allowtotal = IniRead(fname, "Weight", "allowtotal", "Y")       ' Flag for whether to ask total/piece, or always go to piece
        manualweight = IniRead(fname, "Weight", "manualweight", "Y")   ' Flag for whether to display weight dialog, or just accept what is sent

        inivalue = IniRead(fname, "Test", "PrintLabels", "Y")
        If inivalue = "N" Then
            PrintLabels = False
        Else
            PrintLabels = True
        End If

        'MsgBox CStr(lbldisp), , "lblDisp"
        'MsgBox Str(lbport), , "Lbport"
        'MsgBox lblHeat, , "lblheat"
        'MsgBox lblSpeed, , "lblspeed"
        'MsgBox lblOrigin, , "lblorigin"
        'MsgBox CStr(dispman), , "dispman"
        'MsgBox CStr(dispord), , "dispord"
        'MsgBox allowdims, , "allowdims"
        'MsgBox requiredims, , "requiredims"
        'MsgBox allowtotal, , "allowtotal"
        'MsgBox manualweight, , "manualweight"
        'MsgBox PrintLabels, , "PrintLabels"
    Else
        MsgBox "Canlogix.ini Missing. Please create.", , "Config File Error"
    End If

End Sub

Public Sub SetAuto(xstring As String)

    Dim rtnstr As String
    rtnstr = SendNet("SETAUTO" & msgdel & xstring & msgdel)

End Sub

Private Sub SendLogos()

    'Checks for files to upload graphics files to label printer and
    'print a verification label. If they exist, send them both to
    'the label printer.
    
    If fExist(CS32.ShipDir & "loadlogo.bat") And PrintLabels Then
        WinExecMod (CS32.ShipDir & "loadlogo.bat")
    End If
    
    If fExist(CS32.ShipDir & "logovrfy.txt") Then
        Dim myLabel As String
        myLabel = AsciiFile.ReadFileFrom(CS32.ShipDir & "logovrfy.txt")
        lblprinter.SendLabelToPrinter (myLabel)
    End If
    
End Sub
